"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SdJwtVcRecord = void 0;
const core_1 = require("@sd-jwt/core");
const BaseRecord_1 = require("../../../storage/BaseRecord");
const utils_1 = require("../../../utils");
const uuid_1 = require("../../../utils/uuid");
class SdJwtVcRecord extends BaseRecord_1.BaseRecord {
    // TODO: should we also store the pretty claims so it's not needed to
    // re-calculate the hashes each time? I think for now it's fine to re-calculate
    constructor(props) {
        var _a, _b, _c;
        super();
        this.type = SdJwtVcRecord.type;
        if (props) {
            this.id = (_a = props.id) !== null && _a !== void 0 ? _a : (0, uuid_1.uuid)();
            this.createdAt = (_b = props.createdAt) !== null && _b !== void 0 ? _b : new Date();
            this.compactSdJwtVc = props.compactSdJwtVc;
            this._tags = (_c = props.tags) !== null && _c !== void 0 ? _c : {};
        }
    }
    getTags() {
        var _a;
        const sdJwtVc = core_1.SdJwtVc.fromCompact(this.compactSdJwtVc);
        return Object.assign(Object.assign({}, this._tags), { vct: sdJwtVc.getClaimInPayload('vct'), sdAlg: (_a = sdJwtVc.payload._sd_alg) !== null && _a !== void 0 ? _a : 'sha-256', alg: sdJwtVc.getClaimInHeader('alg') });
    }
    clone() {
        return utils_1.JsonTransformer.fromJSON(utils_1.JsonTransformer.toJSON(this), this.constructor);
    }
}
exports.SdJwtVcRecord = SdJwtVcRecord;
SdJwtVcRecord.type = 'SdJwtVcRecord';
//# sourceMappingURL=SdJwtVcRecord.js.map